diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index ca2e0527db..fad14da892 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -1079,7 +1079,8 @@ create_append_plan(PlannerInfo *root, AppendPath *best_path)
 
 	if (enable_partition_pruning &&
 		rel->reloptkind == RELOPT_BASEREL &&
-		best_path->partitioned_rels != NIL)
+		best_path->partitioned_rels != NIL &&
+		root->simple_rte_array[rel->relid]->relkind == RELKIND_PARTITIONED_TABLE)
 	{
 		List	   *prunequal;
 
